<script lang="ts">
import Vue from 'vue';
import { getPageMetadata } from '../../common/meta';
import { NextStep } from '../../components/common/index.vue';
import {
  Conduct,
  Careers,
  EventsSchedule,
  LightningHero,
  Party,
  SpeakerSession,
  Section,
  Intro,
} from '../../components/events/index.vue';
import { CONTENT_TYPES } from '../../common/content-types';
import { getClient } from '~/plugins/contentful.js';
import {
  standardEventsDataHelper,
  EventData,
} from '~/services/events/events.service';

export default Vue.extend({
  components: {
    NextStep,
    Conduct,
    Careers,
    EventsSchedule,
    Party,
    LightningHero,
    Intro,
    Section,
    SpeakerSession,
  },
  nuxtI18n: false,
  async asyncData() {
    const content: EventData = await getClient()
      .getEntries({
        content_type: CONTENT_TYPES.EVENT,
        include: 10,
        'sys.id': '6VKEMI7LxBGtHsGDY65nYl',
      })
      .then((query: any) => {
        const entryFields = query.items[0]?.fields;
        return standardEventsDataHelper(entryFields);
      })
      .catch(console.error);
    return { content };
  },
  head() {
    return getPageMetadata((this as any).content.metadata, this.$route.path);
  },
});
</script>

<template>
  <div>
    <LightningHero
      v-if="content.hero"
      :data="content.hero"
      :dark-mode="false"
    />
    <Intro :data="content.description" :side="true" />
    <Section
      v-for="item in content.booth"
      :key="item.header"
      style="padding-top: 0"
      :data="item"
    />
    <party v-for="item in content.social" :key="item.header" :data="item" />
    <SpeakerSession
      v-for="session in content.sessions"
      :key="session.header"
      :data="session"
    />
    <EventsSchedule :data="content.agenda" :has-dark-background="true" />
    <Careers v-if="content.careers" :data="content.careers" />
    <div v-if="content.footnote">
      <Conduct
        v-for="footnote in content.footnote"
        :key="footnote.header"
        :data="footnote"
      />
    </div>
    <NextStep :variant="content.nextSteps" />
  </div>
</template>
